/*
 * Lightning - A Weather Source API
 * **This API is in BETA release.**  Global lightning archive, updated in real time. The Weather Source Lightning API provides the most accurate and reliable global lightning data available. All matching lightning events within 12 km (7 miles) of a provided location (and within the provided time range) are returned. The global lightning archive is available from the years 2021 and onward.  **IMPORTANT:** To authenticate to the Weather Source Lightning API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page. 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.Grid;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
/**
 * BoundingPointsInner
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-11-20T19:54:05.861Z[GMT]")
public class BoundingPointsInner {
  @SerializedName("onpointId")
  private Integer onpointId = null;

  @SerializedName("latitude")
  private Float latitude = null;

  @SerializedName("longitude")
  private Float longitude = null;

  @SerializedName("grid")
  private Grid grid = null;

  @SerializedName("distance")
  private Float distance = null;

  @SerializedName("elevation")
  private Float elevation = null;

  public BoundingPointsInner onpointId(Integer onpointId) {
    this.onpointId = onpointId;
    return this;
  }

   /**
   * Get onpointId
   * @return onpointId
  **/
  @Schema(required = true, description = "")
  public Integer getOnpointId() {
    return onpointId;
  }

  public void setOnpointId(Integer onpointId) {
    this.onpointId = onpointId;
  }

  public BoundingPointsInner latitude(Float latitude) {
    this.latitude = latitude;
    return this;
  }

   /**
   * Get latitude
   * @return latitude
  **/
  @Schema(required = true, description = "")
  public Float getLatitude() {
    return latitude;
  }

  public void setLatitude(Float latitude) {
    this.latitude = latitude;
  }

  public BoundingPointsInner longitude(Float longitude) {
    this.longitude = longitude;
    return this;
  }

   /**
   * Get longitude
   * @return longitude
  **/
  @Schema(required = true, description = "")
  public Float getLongitude() {
    return longitude;
  }

  public void setLongitude(Float longitude) {
    this.longitude = longitude;
  }

  public BoundingPointsInner grid(Grid grid) {
    this.grid = grid;
    return this;
  }

   /**
   * Get grid
   * @return grid
  **/
  @Schema(required = true, description = "")
  public Grid getGrid() {
    return grid;
  }

  public void setGrid(Grid grid) {
    this.grid = grid;
  }

  public BoundingPointsInner distance(Float distance) {
    this.distance = distance;
    return this;
  }

   /**
   * Get distance
   * @return distance
  **/
  @Schema(required = true, description = "")
  public Float getDistance() {
    return distance;
  }

  public void setDistance(Float distance) {
    this.distance = distance;
  }

  public BoundingPointsInner elevation(Float elevation) {
    this.elevation = elevation;
    return this;
  }

   /**
   * Get elevation
   * @return elevation
  **/
  @Schema(required = true, description = "")
  public Float getElevation() {
    return elevation;
  }

  public void setElevation(Float elevation) {
    this.elevation = elevation;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BoundingPointsInner boundingPointsInner = (BoundingPointsInner) o;
    return Objects.equals(this.onpointId, boundingPointsInner.onpointId) &&
        Objects.equals(this.latitude, boundingPointsInner.latitude) &&
        Objects.equals(this.longitude, boundingPointsInner.longitude) &&
        Objects.equals(this.grid, boundingPointsInner.grid) &&
        Objects.equals(this.distance, boundingPointsInner.distance) &&
        Objects.equals(this.elevation, boundingPointsInner.elevation);
  }

  @Override
  public int hashCode() {
    return Objects.hash(onpointId, latitude, longitude, grid, distance, elevation);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BoundingPointsInner {\n");
    
    sb.append("    onpointId: ").append(toIndentedString(onpointId)).append("\n");
    sb.append("    latitude: ").append(toIndentedString(latitude)).append("\n");
    sb.append("    longitude: ").append(toIndentedString(longitude)).append("\n");
    sb.append("    grid: ").append(toIndentedString(grid)).append("\n");
    sb.append("    distance: ").append(toIndentedString(distance)).append("\n");
    sb.append("    elevation: ").append(toIndentedString(elevation)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
