/*
 * Lightning - A Weather Source API
 * **This API is in BETA release.**  Global lightning archive, updated in real time. The Weather Source Lightning API provides the most accurate and reliable global lightning data available. All matching lightning events within 12 km (7 miles) of a provided location (and within the provided time range) are returned. The global lightning archive is available from the years 2021 and onward.  **IMPORTANT:** To authenticate to the Weather Source Lightning API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page. 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import org.threeten.bp.OffsetDateTime;
/**
 * A lightning object.
 */
@Schema(description = "A lightning object.")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-11-20T19:54:05.861Z[GMT]")
public class LightningObj {
  @SerializedName("timestamp")
  private OffsetDateTime timestamp = null;

  @SerializedName("latitude")
  private Float latitude = null;

  @SerializedName("longitude")
  private Float longitude = null;

  @SerializedName("distance")
  private Float distance = null;

  @SerializedName("peakCurrent")
  private Integer peakCurrent = null;

  @SerializedName("flashMult")
  private Integer flashMult = null;

  @SerializedName("sensorCnt")
  private Integer sensorCnt = null;

  @SerializedName("df")
  private Integer df = null;

  @SerializedName("t")
  private Float t = null;

  @SerializedName("su")
  private Float su = null;

  @SerializedName("sv")
  private Float sv = null;

  @SerializedName("chi2")
  private Float chi2 = null;

  @SerializedName("riseTime")
  private Float riseTime = null;

  @SerializedName("fallTime")
  private Float fallTime = null;

  @SerializedName("rateOfChange")
  private Float rateOfChange = null;

  @SerializedName("cloudFlag")
  private Boolean cloudFlag = null;

  @SerializedName("angleFlag")
  private Boolean angleFlag = null;

  @SerializedName("signalFlag")
  private Boolean signalFlag = null;

  @SerializedName("timingFlag")
  private Boolean timingFlag = null;

  public LightningObj timestamp(OffsetDateTime timestamp) {
    this.timestamp = timestamp;
    return this;
  }

   /**
   * Get timestamp
   * @return timestamp
  **/
  @Schema(required = true, description = "")
  public OffsetDateTime getTimestamp() {
    return timestamp;
  }

  public void setTimestamp(OffsetDateTime timestamp) {
    this.timestamp = timestamp;
  }

  public LightningObj latitude(Float latitude) {
    this.latitude = latitude;
    return this;
  }

   /**
   * Get latitude
   * @return latitude
  **/
  @Schema(required = true, description = "")
  public Float getLatitude() {
    return latitude;
  }

  public void setLatitude(Float latitude) {
    this.latitude = latitude;
  }

  public LightningObj longitude(Float longitude) {
    this.longitude = longitude;
    return this;
  }

   /**
   * Get longitude
   * @return longitude
  **/
  @Schema(required = true, description = "")
  public Float getLongitude() {
    return longitude;
  }

  public void setLongitude(Float longitude) {
    this.longitude = longitude;
  }

  public LightningObj distance(Float distance) {
    this.distance = distance;
    return this;
  }

   /**
   * Get distance
   * @return distance
  **/
  @Schema(description = "")
  public Float getDistance() {
    return distance;
  }

  public void setDistance(Float distance) {
    this.distance = distance;
  }

  public LightningObj peakCurrent(Integer peakCurrent) {
    this.peakCurrent = peakCurrent;
    return this;
  }

   /**
   * Get peakCurrent
   * @return peakCurrent
  **/
  @Schema(description = "")
  public Integer getPeakCurrent() {
    return peakCurrent;
  }

  public void setPeakCurrent(Integer peakCurrent) {
    this.peakCurrent = peakCurrent;
  }

  public LightningObj flashMult(Integer flashMult) {
    this.flashMult = flashMult;
    return this;
  }

   /**
   * Get flashMult
   * @return flashMult
  **/
  @Schema(description = "")
  public Integer getFlashMult() {
    return flashMult;
  }

  public void setFlashMult(Integer flashMult) {
    this.flashMult = flashMult;
  }

  public LightningObj sensorCnt(Integer sensorCnt) {
    this.sensorCnt = sensorCnt;
    return this;
  }

   /**
   * Get sensorCnt
   * @return sensorCnt
  **/
  @Schema(description = "")
  public Integer getSensorCnt() {
    return sensorCnt;
  }

  public void setSensorCnt(Integer sensorCnt) {
    this.sensorCnt = sensorCnt;
  }

  public LightningObj df(Integer df) {
    this.df = df;
    return this;
  }

   /**
   * Get df
   * @return df
  **/
  @Schema(description = "")
  public Integer getDf() {
    return df;
  }

  public void setDf(Integer df) {
    this.df = df;
  }

  public LightningObj t(Float t) {
    this.t = t;
    return this;
  }

   /**
   * Get t
   * @return t
  **/
  @Schema(description = "")
  public Float getT() {
    return t;
  }

  public void setT(Float t) {
    this.t = t;
  }

  public LightningObj su(Float su) {
    this.su = su;
    return this;
  }

   /**
   * Get su
   * @return su
  **/
  @Schema(description = "")
  public Float getSu() {
    return su;
  }

  public void setSu(Float su) {
    this.su = su;
  }

  public LightningObj sv(Float sv) {
    this.sv = sv;
    return this;
  }

   /**
   * Get sv
   * @return sv
  **/
  @Schema(description = "")
  public Float getSv() {
    return sv;
  }

  public void setSv(Float sv) {
    this.sv = sv;
  }

  public LightningObj chi2(Float chi2) {
    this.chi2 = chi2;
    return this;
  }

   /**
   * Get chi2
   * @return chi2
  **/
  @Schema(description = "")
  public Float getChi2() {
    return chi2;
  }

  public void setChi2(Float chi2) {
    this.chi2 = chi2;
  }

  public LightningObj riseTime(Float riseTime) {
    this.riseTime = riseTime;
    return this;
  }

   /**
   * Get riseTime
   * @return riseTime
  **/
  @Schema(description = "")
  public Float getRiseTime() {
    return riseTime;
  }

  public void setRiseTime(Float riseTime) {
    this.riseTime = riseTime;
  }

  public LightningObj fallTime(Float fallTime) {
    this.fallTime = fallTime;
    return this;
  }

   /**
   * Get fallTime
   * @return fallTime
  **/
  @Schema(description = "")
  public Float getFallTime() {
    return fallTime;
  }

  public void setFallTime(Float fallTime) {
    this.fallTime = fallTime;
  }

  public LightningObj rateOfChange(Float rateOfChange) {
    this.rateOfChange = rateOfChange;
    return this;
  }

   /**
   * Get rateOfChange
   * @return rateOfChange
  **/
  @Schema(description = "")
  public Float getRateOfChange() {
    return rateOfChange;
  }

  public void setRateOfChange(Float rateOfChange) {
    this.rateOfChange = rateOfChange;
  }

  public LightningObj cloudFlag(Boolean cloudFlag) {
    this.cloudFlag = cloudFlag;
    return this;
  }

   /**
   * Get cloudFlag
   * @return cloudFlag
  **/
  @Schema(description = "")
  public Boolean getCloudFlag() {
    return cloudFlag;
  }

  public void setCloudFlag(Boolean cloudFlag) {
    this.cloudFlag = cloudFlag;
  }

  public LightningObj angleFlag(Boolean angleFlag) {
    this.angleFlag = angleFlag;
    return this;
  }

   /**
   * Get angleFlag
   * @return angleFlag
  **/
  @Schema(description = "")
  public Boolean getAngleFlag() {
    return angleFlag;
  }

  public void setAngleFlag(Boolean angleFlag) {
    this.angleFlag = angleFlag;
  }

  public LightningObj signalFlag(Boolean signalFlag) {
    this.signalFlag = signalFlag;
    return this;
  }

   /**
   * Get signalFlag
   * @return signalFlag
  **/
  @Schema(description = "")
  public Boolean getSignalFlag() {
    return signalFlag;
  }

  public void setSignalFlag(Boolean signalFlag) {
    this.signalFlag = signalFlag;
  }

  public LightningObj timingFlag(Boolean timingFlag) {
    this.timingFlag = timingFlag;
    return this;
  }

   /**
   * Get timingFlag
   * @return timingFlag
  **/
  @Schema(description = "")
  public Boolean getTimingFlag() {
    return timingFlag;
  }

  public void setTimingFlag(Boolean timingFlag) {
    this.timingFlag = timingFlag;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    LightningObj lightningObj = (LightningObj) o;
    return Objects.equals(this.timestamp, lightningObj.timestamp) &&
        Objects.equals(this.latitude, lightningObj.latitude) &&
        Objects.equals(this.longitude, lightningObj.longitude) &&
        Objects.equals(this.distance, lightningObj.distance) &&
        Objects.equals(this.peakCurrent, lightningObj.peakCurrent) &&
        Objects.equals(this.flashMult, lightningObj.flashMult) &&
        Objects.equals(this.sensorCnt, lightningObj.sensorCnt) &&
        Objects.equals(this.df, lightningObj.df) &&
        Objects.equals(this.t, lightningObj.t) &&
        Objects.equals(this.su, lightningObj.su) &&
        Objects.equals(this.sv, lightningObj.sv) &&
        Objects.equals(this.chi2, lightningObj.chi2) &&
        Objects.equals(this.riseTime, lightningObj.riseTime) &&
        Objects.equals(this.fallTime, lightningObj.fallTime) &&
        Objects.equals(this.rateOfChange, lightningObj.rateOfChange) &&
        Objects.equals(this.cloudFlag, lightningObj.cloudFlag) &&
        Objects.equals(this.angleFlag, lightningObj.angleFlag) &&
        Objects.equals(this.signalFlag, lightningObj.signalFlag) &&
        Objects.equals(this.timingFlag, lightningObj.timingFlag);
  }

  @Override
  public int hashCode() {
    return Objects.hash(timestamp, latitude, longitude, distance, peakCurrent, flashMult, sensorCnt, df, t, su, sv, chi2, riseTime, fallTime, rateOfChange, cloudFlag, angleFlag, signalFlag, timingFlag);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class LightningObj {\n");
    
    sb.append("    timestamp: ").append(toIndentedString(timestamp)).append("\n");
    sb.append("    latitude: ").append(toIndentedString(latitude)).append("\n");
    sb.append("    longitude: ").append(toIndentedString(longitude)).append("\n");
    sb.append("    distance: ").append(toIndentedString(distance)).append("\n");
    sb.append("    peakCurrent: ").append(toIndentedString(peakCurrent)).append("\n");
    sb.append("    flashMult: ").append(toIndentedString(flashMult)).append("\n");
    sb.append("    sensorCnt: ").append(toIndentedString(sensorCnt)).append("\n");
    sb.append("    df: ").append(toIndentedString(df)).append("\n");
    sb.append("    t: ").append(toIndentedString(t)).append("\n");
    sb.append("    su: ").append(toIndentedString(su)).append("\n");
    sb.append("    sv: ").append(toIndentedString(sv)).append("\n");
    sb.append("    chi2: ").append(toIndentedString(chi2)).append("\n");
    sb.append("    riseTime: ").append(toIndentedString(riseTime)).append("\n");
    sb.append("    fallTime: ").append(toIndentedString(fallTime)).append("\n");
    sb.append("    rateOfChange: ").append(toIndentedString(rateOfChange)).append("\n");
    sb.append("    cloudFlag: ").append(toIndentedString(cloudFlag)).append("\n");
    sb.append("    angleFlag: ").append(toIndentedString(angleFlag)).append("\n");
    sb.append("    signalFlag: ").append(toIndentedString(signalFlag)).append("\n");
    sb.append("    timingFlag: ").append(toIndentedString(timingFlag)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
