/*
 * Lightning - A Weather Source API
 * **This API is in BETA release.**  Global lightning archive, updated in real time. The Weather Source Lightning API provides the most accurate and reliable global lightning data available. All matching lightning events within 12 km (7 miles) of a provided location (and within the provided time range) are returned. The global lightning archive is available from the years 2021 and onward.  **IMPORTANT:** To authenticate to the Weather Source Lightning API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page. 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.FieldListObj;
import io.swagger.client.model.LightningArr;
import io.swagger.client.model.PointObj;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
/**
 * Latitude/Longitude lightning object
 */
@Schema(description = "Latitude/Longitude lightning object")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-11-20T19:54:05.861Z[GMT]")
public class LightningPointObj {
  @SerializedName("location")
  private PointObj location = null;

  @SerializedName("fields")
  private FieldListObj fields = null;

  @SerializedName("lightning")
  private LightningArr lightning = null;

  public LightningPointObj location(PointObj location) {
    this.location = location;
    return this;
  }

   /**
   * Get location
   * @return location
  **/
  @Schema(required = true, description = "")
  public PointObj getLocation() {
    return location;
  }

  public void setLocation(PointObj location) {
    this.location = location;
  }

  public LightningPointObj fields(FieldListObj fields) {
    this.fields = fields;
    return this;
  }

   /**
   * Get fields
   * @return fields
  **/
  @Schema(required = true, description = "")
  public FieldListObj getFields() {
    return fields;
  }

  public void setFields(FieldListObj fields) {
    this.fields = fields;
  }

  public LightningPointObj lightning(LightningArr lightning) {
    this.lightning = lightning;
    return this;
  }

   /**
   * Get lightning
   * @return lightning
  **/
  @Schema(required = true, description = "")
  public LightningArr getLightning() {
    return lightning;
  }

  public void setLightning(LightningArr lightning) {
    this.lightning = lightning;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    LightningPointObj lightningPointObj = (LightningPointObj) o;
    return Objects.equals(this.location, lightningPointObj.location) &&
        Objects.equals(this.fields, lightningPointObj.fields) &&
        Objects.equals(this.lightning, lightningPointObj.lightning);
  }

  @Override
  public int hashCode() {
    return Objects.hash(location, fields, lightning);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class LightningPointObj {\n");
    
    sb.append("    location: ").append(toIndentedString(location)).append("\n");
    sb.append("    fields: ").append(toIndentedString(fields)).append("\n");
    sb.append("    lightning: ").append(toIndentedString(lightning)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
