/*
 * Lightning - A Weather Source API
 * **This API is in BETA release.**  Global lightning archive, updated in real time. The Weather Source Lightning API provides the most accurate and reliable global lightning data available. All matching lightning events within 12 km (7 miles) of a provided location (and within the provided time range) are returned. The global lightning archive is available from the years 2021 and onward.  **IMPORTANT:** To authenticate to the Weather Source Lightning API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page. 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.ErrorObj;
import io.swagger.client.model.LightningOnpointObj;
import org.threeten.bp.OffsetDateTime;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for OnpointsApi
 */
@Ignore
public class OnpointsApiTest {

    private final OnpointsApi api = new OnpointsApi();

    /**
     * Lightning data proximate to an OnPoint™ point.
     *
     * Returns all lightning events that are both within 12 km (7 miles) of a provided OnPoint™ point and within the provided time range. The temporal range provided must not exceed 1 year in duration.  **IMPORTANT:** To authenticate to the Weather Source Nowcast API, each request must contain your API key set to a custom header named &#x60;X-API-KEY&#x60;. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key &#x60;C0W60UOFRML47ytbXk4xlLBfv&#x60; to access example locations found in this documentation.  When using the \\\&quot;Try it out\\\&quot; capability in the documentation, the API key should be added by clicking the green \\\&quot;Authorize\\\&quot; button at the top of the page. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void onpointsOnpointIdPeriodTimestampStarttimestampEndGetTest() throws ApiException {
        Integer onpointId = null;
        OffsetDateTime timestampStart = null;
        OffsetDateTime timestampEnd = null;
        List<String> fields = null;
        String unitScale = null;
        Integer limit = null;
        LightningOnpointObj response = api.onpointsOnpointIdPeriodTimestampStarttimestampEndGet(onpointId, timestampStart, timestampEnd, fields, unitScale, limit);

        // TODO: test validations
    }
}
